<h1 align="center">
  <br>
  <img src="docs/src/assets/lipsgit.png" width="200px"/>
  <br>
  lipsgit
  <br>
</h1>

<h4 align="center">
   💄 A command line tool for enabling pretty emoji commits
</h4>


<p align="center">

  <a href="https://codecov.io/gh/jossmoff/lipsgit">
    <img src="https://codecov.io/gh/jossmoff/lipsgit/branch/main/graph/badge.svg" />
  </a>

  <a href="https://github.com/jossmoff/lipsgit/issues">
    <img src="https://img.shields.io/github/issues/jossmoff/lipsgit.svg">
  </a>

  <a href="https://github.com/jossmoff/lipsgit/pulls">
    <img src="https://img.shields.io/github/issues-pr/jossmoff/lipsgit.svg">
  </a>

  <a href="https://github.com/tronprotocol/jossmoff/lipsgit/graphs/contributors">
    <img src="https://img.shields.io/github/contributors/jossmoff/lipsgit.svg">
  </a>

  <a href="LICENSE">
    <img src="https://img.shields.io/github/license/jossmoff/lipsgit.svg">
  </a>

  <a href="https://github.com/astral-sh/ruff">
    <img src="https://img.shields.io/endpoint?url=https://raw.githubusercontent.com/astral-sh/ruff/main/assets/badge/v2.json" alt="Ruff badge" style="max-width:100%;">
  </a>

</p>

## 🤖 Automatically add emojis to your commits with semantic matching

<div align="center">
  <br>
  <img src="docs/src/assets/semantic-match.png" width="60%"/>
  <br>
  <br>
</div>

## ⚙️ Fully customise emoji mappings to suit your team
<div align="center">
  <br>
  <img src="docs/src/assets/custom-emoji.png" width="60%"/>
  <br>
  <br>
</div>

## 🚀 Getting Started

### 🛠️ Installation
Use `pip` to install lipsgit:

```bash
pip install lipsgit
```

To optimally set up lipsgit, follow the [Getting Started guide in the documentation](https://lipsgit.docs.joss.dev/getting-started/installation/).

### 🧑‍💻 Usage
The documentation for lipsgit is available at [lipsgit.docs.joss.dev](https://lipsgit.docs.joss.dev/) and contains a detailed guide on how to use lipsgit.

To list available commands, either run `lipsgit` with no parameters or execute `lipsgit` help:
The base command for the `lipsgit` CLI.

#### Subcommands

| Name                                                                 | Description                                    |
|----------------------------------------------------------------------|------------------------------------------------|
| <a href="https://lipsgit.docs.joss.dev/reference/add/">add</a>       | Add a custom emoji entry to lipsgit            |
| <a href="https://lipsgit.docs.joss.dev/reference/commit/">commit</a> | Interactively commit with an emoji             |
| <a href="https://lipsgit.docs.joss.dev/reference/hook/">hook  </a>   | Run lipsgit as part of a `commit_message` hook |
| <a href="https://lipsgit.docs.joss.dev/reference/init/">init   </a>  | Initialize lipsgit configuration               |

## 🤝 Contributing 

We're excited that you want to contribute to lipsgit. Your help and contributions are greatly appreciated!
Read the [contribution guidelines](CONTRIBUTING.md) to get started.

## 📜 Code of Conduct 

We value your contribution and participation in our community. To ensure a positive and inclusive environment for all, we have established a Code of Conduct.
Read the [Code of Conduct](CODE_OF_CONDUCT.md) to learn more.

